<?php
/**
 * edit:chj
 * date:20140819
 * reason:服务收费产品明细查询  产品、服务合同
 *
 * Description of QueryGenerator
 *
 * @author MAK
 */
class ServiceChargeQueryGenerator extends QueryGenerator {

   
    private $productFocus=null;//产品类对象
    private $serviceContactFocus=null;//服务合同对象

    public $productDetails;
    private $moduleColArray=array();
    public $ProductTableColumn=array();//列头所涉及到的产品相关表
    private $MainTableColumn=array();//列头涉及主表
    public $whereMainTable=array();//查询涉及主表
    public  $whereProductTable=array();//查询涉及到的产品相关表
    private $whereCustomTable=array();//分类基本条件的相关表

	public function __construct($module, $user,$customerview='') {
		 parent::__construct($module, $user,$customerview);
         
        $this->ownerFields['promodifiedby']='modifiedby';
        $this->ownerFields['procreator']='creator';
        $this->ownerFields['proassigned_user_id']='assigned_user_id';
        
        $this->ownerFields['ServiceContractsassigned_user_id']='ServiceContractsassigned_user_id';
        $this->ownerFields['ServiceContractsmodifiedby']='ServiceContractsmodifiedby';
        $this->ownerFields['ServiceContractscreator']='ServiceContractscreator';
       
		$this->createProductDetailsObj();
        $this->productFocus=CRMEntity::getInstance('Products');
        $this->serviceContactFocus=CRMEntity::getInstance("ServiceContracts");
	
	}
    
    public function createProductDetailsObj()
    {
        crm_load_class_file("ProductDetails",'include/ProductDetails');
        $this->productDetails=ProductDetails::getInstance($this->module);
        $this->productDetails->querygenerator=$this;
    }

    public function getPropertyFields()
    {
        return $this->productDetails->fields_property;
    }
	

    /**
    * reason:获取查询列头中主表列头数
    * */
    public function getMainColumnCount()
    {
         global $currentModule;
        $list_fieldproperty=$this->getPropertyFields();
        $focusmodule=$currentModule;
          if($currentModule == 'ServiceCharge')
                    $focusmodule='Accounts';
        foreach($list_fieldproperty as $key=>$modulename)
        {
            if($modulename!=$focusmodule)
            {
               $Num=$key-1;
               break;
               
            }
        }
      
    
         return  $Num;
         
         //return ($Num-1);//删除主表ID
    }

    public function getOrderByClause()
    {
        $producttable=array_filter(array_unique(array_merge($this->ProductTableColumn,$this->whereProductTable)));
        $focus=$this->moduleobj;      
        $baseTable = $focus->table_name;
        
        if(!empty($producttable))
        {
            $orderby .=',ld_servicecontractsdetail.servicecontracts_end_date desc';
        }
        return $orderby;
    }
    public function getWhereClause() {
        global $current_user;
        if(!empty($this->query) || !empty($this->whereClause)) {
            return $this->whereClause;
        }
        crm_load_class_file('cls_query_where','include/QueryGenerator/SqlWhere');
		$deletedQuery = $this->moduleobj->getEntityDeletedQuery();
		$sql = '';
		if(!empty($deletedQuery)) {
			$sql .= " WHERE $deletedQuery";
		}
		if($this->conditionInstanceCount > 0) {
			$sql .= ' AND ';
		} elseif(empty($deletedQuery)) {
			$sql .= ' WHERE ';
		}
		$baseTable = $this->moduleobj->table_name;
		$moduleTableIndexList = $this->moduleobj->tab_name_index;
     
		$baseTableIndex = $moduleTableIndexList[$baseTable];
		$groupSql = $this->groupInfo;
       
		$fieldSqlList = array();
       
        
		foreach ($this->conditionals as $index=>$conditionInfo) {
            if($conditionInfo=='') {continue;}

            if($this->isServiceChargeProductTable($conditionInfo['tablename']))
			{
		    
			   $this->moduleFieldList=$this->productDetails->getModuleFields();
			   $field=$this->moduleFieldList[$conditionInfo['name']];
               $this->whereProductTable[]=$conditionInfo['tablename'];
               $fieldName = $conditionInfo['name'];
			}
            else
            {
                $this->moduleFieldList = $this->fieldobj->getModuleFields();
                $fieldName = $conditionInfo['name'];
                $field = $this->moduleFieldList[$fieldName]; 
               
            }
            if(empty($field)) {
                continue;
            }
			$fieldSql = '(';
			$fieldGlue = '';
           
			$valueSqlList = $this->getConditionValue($conditionInfo['value'],
				$conditionInfo['operator'],$field);
			if(!is_array($valueSqlList)) {
				$valueSqlList = array($valueSqlList);
			}
			foreach ($valueSqlList as $valueSql) {
				if($field->getUIType()==200)//源单为合同订单
				{
					$this->whereProductTable[]='200_ld_salesorder';
					$fieldSql.=" $fieldGlue ld_salesorder.subject $valueSql";
					if($conditionInfo['operator']=='isnull'){
						$fieldSql.=' or ld_salesorder.subject IS NULL ';
					}
				}
				elseif($field->getUIType()==201)//源单为采购订单
				{
					$this->whereProductTable[]='201_ld_purchaseorder';
					$fieldSql.=" $fieldGlue ld_purchaseorder.subject $valueSql";
					if($conditionInfo['operator']=='isnull'){
						$fieldSql.=' or ld_purchaseorder.subject IS NULL ';
					}
				}else if($field->getUIType()==154)
				{
					//chj 2021/10/12 48241: （http://scsaivs.gnway.vip/crm [^]）四川赛维思；服务收费管理模块中，无法通过团队成员查询数据
					crm_load_class_file("cls_query_154",'include/QueryGenerator/SqlWhere/NormalWhere'); 
           
				  $str="cls_query_154";
				  $whereobj=new $str($this->module,$field,$conditionInfo,$this->moduleobj,$valueSql);
				  $whereobj->getWhereCondition();
				  $fieldSql.= $fieldGlue.$whereobj->fieldSql;
				}
			
		
                 elseif (in_array($fieldName, $this->referenceFieldList)) {
				    
                    crm_load_class_file("cls_referenceFieldList_where",'include/QueryGenerator/SqlWhere'); 
                    $whereobj=new cls_referenceFieldList_where($this->module,$field,$conditionInfo,$this->moduleobj,$valueSql,$this);
                    $whereobj->setWhere_jointable_Prefix($this->wheretablePrefix);
                    $whereobj->getWhereCondition();
                    $fieldSql.=$whereobj->fieldSql;
                    $field_table_index=$this->moduleobj->tab_name_index[$field->getTableName()];
                  
                    //edit:can 20220119 49750: （http://crm.3rensoft.com:85/crm/ [^] ）（伙伴问题）：2.服务收费管理中高级查找以使用产品字段为选择查找条件时只能查到有多少条记录，不会在序时簿界面显示

                    if($field->getTableName()==$this->moduleobj->customFieldTable[0])
                      {
                        //当选择字段在定义表，查询有错误
                            $tablescf=$this->moduleobj->customFieldTable[0];
                            $tablescfindex=$this->moduleobj->customFieldTable[1];
                            $maintablename=$this->moduleobj->table_name;
                            $maintableindex=$this->moduleobj->table_index;
                            $this->whereMainTable[$field->getTableName()]= "  $tablescf on $tablescf.$tablescfindex=$maintablename.$maintableindex ";
                           
                            
                      }
                    if($whereobj->where_jointablename!='')
                    {
                        
                        $this->whereMainTable[$whereobj->where_jointablename]=$whereobj->whereFieldTable;
                    }
            
					/*$moduleList = $this->referenceFieldInfoList[$fieldName];
                   
					foreach($moduleList as $module) {
					   	$tmp_field_obj = $this->getMeta($module);
						$nameFields = $this->moduleNameFields[$module];
                        $tmp_focus=CRMEntity::getInstance($module);
                        
						$nameFieldList = explode(',',$nameFields);
						$columnList = array();
						foreach ($nameFieldList as $column) {
						
						
								$referenceField = $tmp_field_obj->getFieldByColumnName($column);
								$referenceTable = $referenceField->getTableName();

								if($baseTable != $referenceTable)
									$this->whereMainTable[$referenceTable]=$referenceTable.' on '.$referenceTable.'.'.$tmp_focus->table_index.'='.$field->getTableName().'.'.$field->getColumnName();//关联表
						       $oldreferencetable=$referenceTable;
							if(isset($moduleTableIndexList[$referenceTable])) {
								$referenceTable = "$referenceTable$fieldName";
                                $this->whereMainTable[$referenceTable]=' ld_account as '.$referenceTable.' on '.$referenceTable.'.parentid=ld_account.accountid';//关联表
							}
							$columnList[] = "$referenceTable.$column";
						}
                        
					    $columnSql = implode('', $columnList);
					
						$fieldSql .= "$fieldGlue trim($columnSql) $valueSql";
                            if($conditionInfo['operator']=='isnull'){
                                $fieldSql.=' or '.trim($columnSql).' IS NULL ';
                            }
						$fieldGlue = ' OR';
					}*/
				}
                 elseif(Field::user_fields($field->getUIType()))//审批人,创建人，最近更新人,53:收款单审核人,100:提醒人
                 {
                            if($this->isServiceChargeProductTable($field->getTableName()))
                            {
                                if(isProductTable($field->getTableName(),$this->moduleobj->module_name))
                                {
                                    $astablename='users_Products_'.$fieldName;
                                }
                                else
                                {
                                    $astablename='users_ServicContracts_'.$fieldName;
                                }
                               
                            }
                            else
                                $astablename="users_$fieldName";
                            // $concatSql="$astablename.last_name";
                            
                           // $fieldSql .= "$fieldGlue trim($concatSql) $valueSql ";
                           
                        crm_load_class_file('cls_where_user','include/QueryGenerator/SqlWhere/NormalWhere'); 

                      $whereobj=new cls_where_user($this->module,$field,$conditionInfo,$this->moduleobj,$valueSql);
                      $whereobj->setAsTablename($astablename);
                      
                      $whereobj->getWhereCondition();
                      $fieldSql.= $fieldGlue.$whereobj->fieldSql;
						
                    // if($field->getTableName()!=$maintablename)
                        //    $this->whereFieldTables[$field->getTableName()]= "  $tablescf on $tablescf.$tablescfindex=$maintablename.$maintableindex ";
					if($field->getTableName() != $baseTable && !array_key_exists(strtolower($field->getTableName()),$this->whereMainTable)){
						$this->whereMainTable[$field->getTableName()]=$field->getTableName() . ' on '.$field->getTableName().'.'.$moduleTableIndexList[$field->getTableName()].'='.$baseTable.'.'.$moduleTableIndexList[$field->getTableName()];
					 }
                     $this->whereMainTable[$astablename]=' ld_users as '.$astablename.' on '.$astablename.'.id='.$field->getTableName().'.'.$field->getColumnName();
					 

                     //dump($fieldSql);
                     
                          /*  if($conditionInfo['operator']=='isnull'){
                                $fieldSql.=' or '.trim($concatSql).' IS NULL  or '
                                    .$field->getTableName().".". $field->getColumnName().'=0';
                            }
                            else if($conditionInfo['operator']=='isnotnull')
                            {
                                $fieldSql.=' or '.trim($concatSql).' IS not NULL  or '
                                    .$field->getTableName().".". $field->getColumnName().'>0';
                            }
                            $this->whereMainTable[$astablename]=' ld_users as '.$astablename.' on '.$astablename.'.id='.$field->getTableName().'.'.$field->getColumnName();
                            */
                 }
                 else if (file_exists(globalStatic::$root_directory."include/QueryGenerator/SqlWhere/NormalWhere/cls_query_".$field->getUIType().".php"))
                {
                              
                     crm_load_class_file("cls_query_".$field->getUIType(),'include/QueryGenerator/SqlWhere/NormalWhere'); 
                   
                      $str="cls_query_".$field->getUIType();
                      $whereobj=new $str($this->module,$field,$conditionInfo,$this->moduleobj,$valueSql);
                      $whereobj->setWhere_jointable_Prefix($this->wheretablePrefix);
                      if($field->getTableName()==$this->moduleobj->customFieldTable[0])
                      {
                        //当选择字段在定义表，查询有错误
                            $tablescf=$this->moduleobj->customFieldTable[0];
                            $tablescfindex=$this->moduleobj->customFieldTable[1];
                            $maintablename=$this->moduleobj->table_name;
                            $maintableindex=$this->moduleobj->table_index;
                            $this->whereFieldTables[$field->getTableName()]= "  $tablescf on $tablescf.$tablescfindex=$maintablename.$maintableindex ";
                            
                      }
                      $whereobj->getWhereCondition();
                     
                      $fieldSql.= $fieldGlue.$whereobj->fieldSql;
                     
                      if(!empty($whereobj->where_jointablename))
                      {
                        $leftjointablename=$whereobj->where_jointablename;
                         $this->whereFieldTables[$whereobj->where_jointablename]=$whereobj->whereFieldTable;
                      }
                      if(!empty($whereobj->where_jointype)){
                            //获取表连接类型（inner join left join )//kehu001当前审批人查询会使用
                            $this->whereFieldTableJoinType[$whereobj->where_jointablename]=$whereobj->where_jointype ;
                      }
                                        
                }
                else {
                    
						$fieldSql .= "$fieldGlue ".$field->getTableName().'.'.
								$field->getColumnName().' '.$valueSql;
                            if($conditionInfo['operator']=='isnull'){
                                $fieldSql.=' or '.$field->getTableName().'.'.
								$field->getColumnName().' IS NULL ';
                            }
                        
				  if($field->getTableName()=='ld_accountscf')
                  {
                    
                    //高级查询中有自定义字段
                    $this->whereMainTable['ld_accountscf']='  ld_accountscf on ld_accountscf.accountid=ld_account.accountid';
                  }else if($field->getTableName()=='ld_contactscf')
                  {
					  //chj 2021/10/26 48412: （https://xx.dongmaoguoji.cn/crm [^] ）（东贸）企业微信移动端》大巴车档案，下游客户档案，点进去显示空的，列表没有数据
                    if(empty($this->whereMainTable['ld_contactdetails'])){
						$this->whereMainTable['ld_contactdetails'] = ' ld_contactdetails on ld_contactdetails.accountid=ld_account.accountid';
					}
                    //高级查询中有自定义字段
					if(empty($this->whereMainTable['ld_contactscf'])){
						$this->whereMainTable['ld_contactscf']='  ld_contactscf on ld_contactscf.contactid=ld_contactdetails.contactid';
					}
                  }
                  else
                       $this->whereCustomTable[] = $field->getTableName(); //分类条件的关联表
				}
				$fieldGlue = ' OR';
			}
			$fieldSql .= ')';
			$fieldSqlList[$index] = $fieldSql;
		}
       $this->whereFieldTables=$this->whereMainTable;
		$groupSql = $this->makeGroupSqlReplacements($fieldSqlList, $groupSql);
        
		if($this->conditionInstanceCount > 0) {
			$this->conditionalWhere = $groupSql;//$groupSql是视图的查询条件
			$sql .= $groupSql;
            
		}
     
		$sql .= " AND $baseTable.$baseTableIndex > 0";
       
        $this->whereProductTable=array_unique($this->whereProductTable);
      //  $this->whereMainTable=array_unique($this->whereMainTable);
        //print_r( $this->whereMainTable);
        //重新按数组小标重组数据
        $whereprocolumns=implode(',', $this->whereProductTable);
        $wheremaincolumns=implode(',', $this->whereMainTable);
        $this->whereProductTable=explode(',',$whereprocolumns);
       // $this->whereMainTable=explode(',',$wheremaincolumns);
		$sql=str_replace(DATACATEGORYSEACHEMPTYVALUE,'',$sql);
        //zkt 列表界面、选择产品界面增加树结构显示
        if(isset($_REQUEST['isshowModuleListTree'])&&$_REQUEST['isshowModuleListTree']=='yes')
        {
            
            $modulequery = $this ->getModuletreelistconditonquery();
            $sql .= $modulequery;
        }
        //dump($sql);
		$this->whereClause = $sql;
    
		return $sql;
	}
    /**
     * edit:chj
     * reason:弹出框的sql语句
     * */
    public function SpecialPopup()
    {
        
        if(empty($this->popufromclasuse))
        {
             $focus=$this->moduleobj;
             if($_REQUEST['accountid']&&stripos($this->getInnerFromClause,'ld_account')<=0)       
               {
                    $this->popufromclasuse.=' left join ld_account  on ld_account.accountid='.$focus->table_name.'.accountid';
                    $this->popuwhereclause.= ' and ld_account.accountid='.$_REQUEST['accountid'];
               }
             if($_REQUEST['vendorid']&&stripos($this->getInnerFromClause,'ld_vendor')<=0)  
             {
                $this->popufromclasuse.=' left join ld_vendor  on ld_vendor.vendorid='.$focus->table_name.'.vendorid';
                $this->popuwhereclause.= ' and ld_vendor.vendorid='.$_REQUEST['vendorid'];
             }
             /**
              * edit:chj
              * reason: frommodule 哪个模块点击出当前弹出框
              * balanceoutproductcount  未出库 
              * balancepurchasecount 未采购
              * */
             if(isset($_REQUEST['frommodule']))
             {
                if($_REQUEST['frommodule'] == 'OutboundOrder' || $_REQUEST['frommodule'] == 'PurchaseOrder')
                    $sql.=" and ld_servicecontractsdetail.balanceoutproductcount >0 ";
                else if($_REQUEST['frommodule'] == 'Stock')
                    $sql.=" and ld_servicecontractsdetail.balancepurchasecount >0 ";
             }
        }
        if(empty($this->popuselectcolumn))
        {
			$tablename = $this->moduleobj->table_name;
			$tableindex = $this->moduleobj->tab_name_index[$tablename];
			if(!empty($tablename) && !empty($tableindex)){
				$this->popuselectcolumn = ' ,'.$tablename.'.'.$tableindex.' as crmid ';
			}
        }
        
        
    }
    /**
     * reason:获取列头,同时获取列头查询涉及的表
     * */
    function getSelectColumn($tabid)
    {
        global $adb;
         if(!empty($this->columns))
         {
            return $this->columns;
         }
        $moduleFields = $this->fieldobj->getModuleFields();//lingdangcrmobjectmeta.php
        $accessibleFieldList = array_keys($moduleFields);//获取当前用户能够看见的字段
        $accessibleFieldList[]='id';
      
		$selectSql =trim($this->productDetails->getSelectColumn($tabid),',');
		/**
		 * 序时薄可以显示产品的字段，这些字段储存在专门的表中，所以
		 * 需要把其中的crmentity替换掉
		 * @project PROT12 crmentity 表结构优化
		 * @author Tujt 2014-06-25
		 */
		$basetable = $this->moduleobj->table_name;
		$selectSql = strtr($selectSql,array('ld_crmentity.'=>$basetable.'.'));

        $columnlist=array_filter(explode(',',$selectSql));
        $finalcolumnlist=array();
       
        for($i=0;$i<sizeof($columnlist);$i++)
        {
             $coltables=explode('.',$columnlist[$i]);
             if($coltables[0]=='ld_attachments')
                continue;
             //isServiceChargeProductTable 判断查询字段是否为产品明细
             if($this->isServiceChargeProductTable($coltables[0]))
             {
				 //0026133: 服务收费管理取值问题： 服务收费关联服务合同，服务合同选择同一个产品有这个问题，不同的产品是没有问题的。
				 if($coltables[1] == 'servicecontracts_end_date'){
					$finalcolumnlist[]='max('.$coltables[0].'.'.$coltables[1] . ') as products_'.$coltables[1];//主表和明细表都有折扣百分比,直接降价字段
				 }else{
					$finalcolumnlist[]=$coltables[0].'.'.$coltables[1] . ' as products_'.$coltables[1];//主表和明细表都有折扣百分比,直接降价字段
				 }
                
                $this->ProductTableColumn[]=$coltables[0];
                continue;
             }
            $finalcolumnlist[]=$coltables[0].'.'.$coltables[1];
          $this->selecttables[$coltables[0]]=$coltables[0];
          $this->MainTableColumn[$coltables[0]]=$coltables[0];
          
            
        }
       // $this->MainTableColumn[] = 'ld_users~~servicecasher';
        //$this->ProductTableColumn[]='ld_inventoryproductrel';
        $this->ProductTableColumn=array_unique($this->ProductTableColumn);//删除数组重复内容
     
        //重新按数组小标重组数据
        $productcolumns=implode(',',$this->ProductTableColumn);
        $this->ProductTableColumn=explode(',',$productcolumns);
       
        $this->columns=implode(',',$finalcolumnlist);
        $focus = $this->moduleobj;
     
        $baseTable = $focus->table_name;
        $baseTableIndex = $focus->table_index;
        $detailtable='ld_servicecontractsdetail';
        $producttable=array_filter(array_unique(array_merge($this->ProductTableColumn,$this->whereProductTable)));
        if(!empty($producttable))
            $this->columns.=" , $detailtable.id,ifnull($detailtable.lineitem_id,0) as lineitem_id,ld_servicecontracts.currency_id, ".$baseTable.'.'.$baseTableIndex;
        else
            $this->columns.=', ' . $baseTable.'.'.$baseTableIndex;   

        return $this->columns;
    }
    public function getQuery($popup='',$type='1')
    {
        return $this->getProductListQuery($type,$popup);
    }
    public function getFromClause()
    {
        return $this->getInnerFromClause();
    }
    /**
     * edit:chj
     * date:2014-8-25
     * reason:获取查询语句
     * $type:1:表示获取分页查询语句
     * $type:2表示获取select和from子句
     * */
    private function getProductListQuery($type,$popup='')
    {
        global $theme;
        global $current_user,$currentModule;
        $limit = "";
        $focus = $this->moduleobj;
        $tab_name = $focus->tab_name;
        $baseTable = $focus->table_name;
        $baseTableIndex = $focus->table_index;
        $tabid = getTabId($this->module);
        $baseTableIndex = $focus->table_index;
        $selectColumn=$this->getSelectColumn($tabid);
        $this->chart_owner="";
        $where=$this->getWhereClause();
	   list($order_listquery,$order_by,$sorder) = $this->customview->getOrderWhere($order_listquery,'',$this);
        $customwhere = $this->isWhereCustionTable();
        $innerfromclause=$this->getInnerFromClause();
  
		$this->chart_from=$innerfromclause;
        $puputype=$popup;
        
        if($puputype=='droppop'&&!is_admin($current_user))//edit:can 20210329 45125: （http://51mis.com.cn/XS/hzxmz [^] ）（杭州小拇指）企业微信端-油漆美容巡店检查指导表；新建时选择门店编号，输入1919没有查询到单据。pc端是可以查询到的
            {
                if(isset($_REQUEST['related_pop_type'])&&$_REQUEST['related_pop_type']=='signin' ||$_REQUEST['selectrelationfrom']=='entry'){
                        
					if(isset($_REQUEST['related_pop_type'])&&$_REQUEST['related_pop_type']=='signin')
						//签到选择源单
						$frommodule='Singin';
					else
						$frommodule=$_REQUEST['frommodule'];
					$fromfocus=CRMEntity::getInstance($_REQUEST['frommodule']);
					if(!empty($_REQUEST['fieldname'])){
						$fieldinfo=$fromfocus->detailfieldobj->getFieldInfoobjBykey("columnname",$_REQUEST['fieldname']);
						
						if(strtolower($fieldinfo->getBigType())=='selectsource'){
							  crm_load_class_file('cls_OptionModule', 'include/OptionModule');
							  $optionmoduleobj = cls_OptionModule::getInstance($frommodule);
							
							  $options = $optionmoduleobj->getData();
							  $sql ='select tabid from ld_tab where name=?';
							 
							 
							  $result=$adb->pquery($sql,array($frommodule));
							  $tabid=$adb->query_result($result,0,'tabid');
							   
							  $option_tabid = getTabid($this->moduleobj->module_name);
							  $maxrowsshow = $options[$tabid][$option_tabid]['maxrowsshow'];
							  $datarang=$options[$tabid][$option_tabid]['datarang'];;//数据查看范围all,permit;
						}else{
							$datarang=$fieldinfo->getDataRang();//数据查看范围all,permit;
						}
					}
                    //editor:gyq_148 reason:企业微信新增工作协同选择客户联系人  2019/10/11 15:17
                }elseif($_REQUEST['frommodule']=='Work'&&$weixin_user->environment_weixin){
                    $datarang='permit';
                }else{
    				 $frommodule=$_REQUEST['frommodule'];
                    $fromfocus=CRMEntity::getInstance($frommodule);
                    $fieldname=$_REQUEST['fieldname'];
                    //editor:gyq_20191202 reason:原生app新增合同订单选择产品报错
                    if(!empty($fieldname)){
                        $fieldinfo=$fromfocus->fieldobj->getFieldInfoobjBykey("fieldname",$fieldname);
                        $datarang=$fieldinfo->getDataRang();//数据查看范围all,permit;
                    }
                }
				if($datarang=='permit'){
					$this->chart_owner.=$this->getSmOwnerSearchSql;
				}
            }
            else
            {
               
                $this->chart_owner.=$this->getSmOwnerSearchSql;
                
            } 
        $this->chart_where=$where;
       if($popup=='popup') $this->SpecialPopup();
    
        $tablename = $this->moduleobj->table_name;
       
        if($type==1||$type==4)
        {
                if(empty($this->ProductTableColumn) && $customwhere==true)   //如何没有服务合同跟产品的明细的清空下，直接返回
                {
                    return '';
                }
                $reportertousersql=$this->getReporttoUserSql();//edit:can 20200826 用户界面 汇报人；
            
                if($this->isWhereCustionTable() == false || preg_grep("/".$this->serviceContactFocus->table_name."/i",$this->whereProductTable))
                {
             
                    $fromclause .='  from ' . $this->getServiceChargeInventoryQuery();
                }
                else  if(preg_grep("/".$this->productFocus->table_name."/i",$this->whereProductTable)||preg_grep("/ld_servicecontractsdetail/i",$this->whereProductTable))  //客户和服务合同和产品明细
                {
                    $fromclause .= " FROM " . $this->getServiceChargeInventoryQuery();
                }
               else 
               {
                $fromclause=' FROM ' .$baseTable;
               }
                
              
               foreach($this->whereMainTable as $tablename=>$leftjoin)
               {
                    if($tablename=='ld_contactdetails')
                    {
                        $fromclause.=' left join ld_contactdetails on ld_contactdetails.accountid=ld_account.accountid';
                    }
                    else
                    {
                        $fromclause.=' left join '.$leftjoin;
                    }
                    
               }
             //32221: 快速查找中：查找“服务收费管理”模块的单据，结果查找不出数据
			//	$fromclause .= $this->getMainFromClause();
				if(!array_key_exists("ld_accountscf",$this->whereMainTable)
                    
                    &&array_key_exists("ld_accountscf",$this->moduleobj->orderby_tables))
				 {
							//32294: 服务收费管理序时簿界面：管理分类-新建分类，设置查找条件，任意设置一个字段，结果筛选不出数据
							$fromclause.=" left join ld_accountscf on ld_accountscf.accountid=ld_account.accountid ";
				 }
					
               if(!empty($reportertousersql))
               {
                  $reportertousersql.=$fromclause;
               }
                if(!is_admin($current_user))
                    $fromclause.=' left join ld_tabshare on ld_tabshare.crmid=ld_account.accountid ';
                 if($this->scopeobj)
                      $scopesql=  $this->scopeobj->getModuleListViewQuery();
                else
                    $scopesql='';
                
                if($type==4){
                    $tmpsql=  ' SELECT count( distinct  '.$baseTable.'.'.$focus->table_index.')'.$fromclause.$this->popufromclasuse .$where.$this->popuwhereclause.$this->chart_owner.$this->whereRangeQuery();
                }
                else
                 {
                    if(empty($scopesql)||empty($reportertousersql))
                         $tmpsql=  ' SELECT distinct  '.$baseTable.'.'.$focus->table_index.$fromclause.$this->popufromclasuse .$where.$this->popuwhereclause.$this->chart_owner.$this->whereRangeQuery();
                    else{
                        $tablename=$this->moduleobj->table_name;
                        $tableindex=$this->moduleobj->table_index;
                        $tmpsql= ' SELECT distinct  '.$baseTable.'.'.$focus->table_index.$fromclause.$this->popufromclasuse .$where.$this->popuwhereclause;
                        
                        $tmpsql=$tmpsql.$this->chart_owner.' union all '.$reportertousersql.$fromclause.$this->popufromclasuse .$where.$this->popuwhereclause;
                        $tmpsql="select  tmp_Tmp_table.* from $tablename inner join   ( $tmpsql) as tmp_Tmp_table 
                           on $tablename.$tableindex=tmp_Tmp_table.$tableindex $joinsql $this->chart_where  ";
                    }
                    
                 }  
                    
                 return html_entity_decode($tmpsql);
         }
        elseif($type==2)
        {
   
            if(stripos($selectColumn,'ld_servicecontracts')!==false)
            {
                //38036: （pc端）服务收费管理列表界面：服务合同编号字段添加一个超链功能，点击可跳转至对于的服务合同明细界面。（可参照客户名称字段）
                 return ' SELECT distinct ld_servicecontracts.servicecontractsid,'.$selectColumn.$this->popuselectcolumn. $this->noPinyinFromClause.$this->popufromclasuse;
            }
            else
            return ' SELECT distinct '.$selectColumn.$this->popuselectcolumn. $this->noPinyinFromClause.$this->popufromclasuse;
            
        } 
       
    }
     public function getGroupBy()
    {
        $detailtable='ld_servicecontractsdetail';
      if(sizeof($this->ProductTableColumn)>0&&$this->ProductTableColumn[0]!='')
            return " group by  ld_account.accountid, $detailtable.productid";
      else
            return ' ';
            
    }
	/**
	* V6.0 角色权限改进
	* @reason 获取 授权范围、共享、查看自己创建的单据 条件
	* 只有查看在全部的情况下，才会去获取以上条件
	* @author Chj 
	*/
	public function whereRangeQuery()
	{
	   //edit:can reason:14505: 控制面板>用户管理：允许查询自己创建的单据设为否，结果在模块列表界面通过查看范围【我创建的】还是能查询到负责人是其他人但创建人是自己的单据
		//if($this->getSmOwnerSearchSql() == '')
			return $this->listviewRangeQuery;
	}
   
  
	public function getSQLColumn($name) {
		if ($name == 'id') {
			$baseTable = $this->moduleobj->table_name;
			$moduleTableIndexList = $this->moduleobj->tab_name_index;
			$baseTableIndex = $moduleTableIndexList[$baseTable];
			return $baseTable.'.'.$baseTableIndex;
		}
		$moduleFields = $this->fieldobj->getModuleFields();
		$field = $moduleFields[$name];
		$sql = '';
		$column = $field->getColumnName();
		return $field->getTableName().'.'.$column;
	}
    public function setMaintable_nameSql()
    {
        return '';
        
    }
    public function getInnerFromClause()
    {
        if(!empty($this->getInnerFromClause))
        {
            return $this->getInnerFromClause;
        }
      
        $producttable=array_filter(array_unique(array_merge($this->ProductTableColumn,$this->whereProductTable)));
        
      
        $focus=$this->moduleobj;      
        $baseTable = $focus->table_name;
        //$this->isWhereCustionTable() 分类基本查询条件中是否包含产品明细
        if($this->isWhereCustionTable() == false || preg_grep("/".$this->serviceContactFocus->table_name."/i",$producttable))
        {
     
            $sql =' FROM ' . $this->getServiceChargeInventoryQuery();
        }
        else  if(preg_grep("/".$this->productFocus->table_name."/i",$producttable)||preg_grep("/ld_servicecontractsdetail/i",$producttable))  //客户和服务合同和产品明细
        {
            $sql = " FROM " . $this->getServiceChargeInventoryQuery();
        }
        else
        {
            $sql = " from $baseTable ";
        }
         $contactfocus=CRMEntity::getInstance("Contacts");
         $usercount=0;
  
       
        $sql.=' '.$this->getMainFromClause();
       
         
  
        $this->noPinyinFromClause=$sql;
        if ( isset($_REQUEST['search_field'])  && $_REQUEST['search_field'] != ''&&isset($_REQUEST['type'])&& strtolower($_REQUEST['type'])== 'alpbt'){
            $sql .= " inner join  ld_cosler c on ((CONV(HEX(convert(left(".$_REQUEST['search_field'].",1) using gbk)),16,10) between c.cBegin and c.cEnd and f_PY like '".$_REQUEST['search_text']."%') or ".$_REQUEST['search_field']." like '".$_REQUEST['search_text']."%')";
        } 
          
        $sql.=$this->gettabshareSql();
		
        
		$this->getInnerFromClause = $sql;
		return $sql;
      
    }
    
    
   /**
    * edit:chj
    * date:2014-9-5
    * reason:服务收费关于产品与服务合同的SQL关联语句
    * */
   public function getServiceChargeInventoryQuery()
   {
     
               //同一个服务合同有两个相同的产品，服务开始日期取服务到期日最大的一行产品
               //26383: 服务到期日应不判断回收站服务合同的到期日 添加了服务合同的deleted=0
               //42817: （https://61mis.com/kfbcrm [^]）客户问题（熊少波的客户问题），客户相关信息中关联创建服务合同保存后，服务收费管理【单据列表】界面，产品分录中的【服务截止日期】应该取客户关联创建该产品的最晚服务截止日期（需要补丁）
               
    /* $sql = "    ld_account
        LEFT JOIN (
        	SELECT
        		accountid,
        		servicecontractsid,
        		servicecontracts_end_date,
        		servicecontracts_start_date,
        		productid,
        		lineitem_id
        	FROM (
        		SELECT
        			ld_servicecontracts.accountid,
        			ld_servicecontracts.servicecontractsid,
        			ld_servicecontractsdetail.servicecontracts_end_date,
        			ld_servicecontractsdetail.servicecontracts_start_date,
        			ld_servicecontractsdetail.productid,
        			ld_servicecontractsdetail.lineitem_id
        		FROM ld_servicecontracts 
        		inner JOIN ld_servicecontractsdetail ON ld_servicecontracts.servicecontractsid=ld_servicecontractsdetail.id
        		WHERE ld_servicecontracts.deleted=0
        			AND ld_servicecontracts.accountid>0
        			AND IFNULL(ld_servicecontracts.contract_status,'')<>'已作废'
        			AND ld_servicecontracts.approvestatus<>'已拒绝'
                    having 1 
        	       order by servicecontracts_end_date desc
        	) a
        	GROUP BY accountid,productid
        ) AS serviceinfo ON ld_account.accountid=serviceinfo.accountid
        LEFT JOIN ld_servicecontracts ON ld_servicecontracts.servicecontractsid=serviceinfo.servicecontractsid
        left join ld_servicecontractscf on ld_servicecontractscf.servicecontractsid=ld_servicecontracts.servicecontractsid

        LEFT JOIN ld_servicecontractsdetail ON ld_servicecontractsdetail.lineitem_id=serviceinfo.lineitem_id
        LEFT JOIN ld_products ON ld_products.productid = serviceinfo.productid
        LEFT JOIN ld_productcf ON ld_productcf.productid = ld_products.productid ";*/
                
   
                 
                 
                $sql = "    ld_account
        
        LEFT JOIN ld_servicecontracts ON ld_account.accountid=ld_servicecontracts.accountid and ld_servicecontracts.deleted = 0 
        left join ld_servicecontractscf on ld_servicecontractscf.servicecontractsid=ld_servicecontracts.servicecontractsid

        left JOIN ld_servicecontractsdetail ON ld_servicecontractsdetail.id=ld_servicecontracts.servicecontractsid
        LEFT JOIN ld_products ON ld_products.productid = ld_servicecontractsdetail.productid
        LEFT JOIN ld_productcf ON ld_productcf.productid = ld_products.productid
        
        LEFT JOIN (
        	SELECT
        		accountid,
        		servicecontractsid,
        		servicecontracts_end_date,
        		servicecontracts_start_date,
        		productid,
        		lineitem_id
        	FROM (
        		SELECT
        			ld_servicecontracts.accountid,
        			ld_servicecontracts.servicecontractsid,
        			ld_servicecontractsdetail.servicecontracts_end_date,
        			ld_servicecontractsdetail.servicecontracts_start_date,
        			ld_servicecontractsdetail.productid,
        			ld_servicecontractsdetail.lineitem_id
        		FROM ld_servicecontracts 
        		inner JOIN ld_servicecontractsdetail ON ld_servicecontracts.servicecontractsid=ld_servicecontractsdetail.id
        		WHERE ld_servicecontracts.deleted=0
        			AND ld_servicecontracts.accountid>0
        			AND IFNULL(ld_servicecontracts.contract_status,'')<>'已作废'
        			AND ld_servicecontracts.approvestatus<>'已拒绝'
                    having 1 
        	       order by servicecontracts_end_date desc
        	) a
        	GROUP BY accountid,productid
        ) AS serviceinfo ON ld_account.accountid=serviceinfo.accountid 
      and   ld_servicecontractsdetail.lineitem_id=serviceinfo.lineitem_id 
      and ld_products.productid = serviceinfo.productid";
                
   
                 
               
        return $sql;
   }
    

	public function addCondition($fieldname,$value,$operator,$tablename='',$glue= null,$newGroup = false,
			$newGroupType = null) {
       /*
       BY LD tifa 20130121
       reason:汉语拼音首字母查询
       description:查询条件在getfromclause()中
       */
       /*
       edit:Can
       date:20130607
       reason:3938: 查找中的 字母查询，应该与视图和查看范围进行关联查询
       
       */
     if($value==''&&$operator!='isnotnull'&&$operator!='isnull')//34443: 单据列表界面>基本查找：应该允许关键字为空时进行搜索。预期：当关键字为空时进行搜索默认为搜索全部。
        return ;
		$conditionNumber = $this->conditionInstanceCount++;
       
		$this->groupInfo .= "$conditionNumber ";
		$this->whereFields[] = $fieldname;
		$this->reset();
        
        if($this->getConditionalArray($fieldname,
				$value, $operator)!='')
		$this->conditionals[$conditionNumber] = $this->getConditionalArray($fieldname,
				$value, $operator,$tablename);
                 
                
	}
     public function getModuleFieldList()
    {
          if(empty($this->moduleFieldList))
          {
            $this->moduleFieldList=$this->fieldobj->getModuleFields();
          }
          return $this->moduleFieldList;
    }
	 public function getCustomViewFieldObj($tablename,$fieldname)
    {
        $moduleFields=$this->getModuleFieldList();
         $productModuleFields= $this->productDetails->getModuleFields();      
          if($this->isServiceChargeProductTable($tablename))
          {
                    //判断当前模块字段是否在主模块可显字段中
                    $objfield=$productModuleFields[$fieldname];
                    
          }
          else
          {
                    //判断当前产品字段是否在产品模块可显示字段中
                    $objfield=$moduleFields[$fieldname];
                   
          }
          return $objfield;
    }
    
  
    
    private function isWhereCustionTable()
    {
        $focus = $this->moduleobj;
        if(isset($this->whereCustomTable))
        {
            foreach($this->whereCustomTable as $key => $val)
            {
                if(!preg_grep("/$val/i",$focus->tab_name))
                {
                    return false;
                }
            }
        }
        return true;
    }
    private function isServiceChargeProductTable($tablename)
    {
        if(strtolower($tablename)=='ld_products'||strtolower($tablename)=='ld_productcf'
            ||strtolower($tablename)=='ld_servicecontractsdetail'||strtolower($tablename)=='ld_servicecontractsdetailscf'
            ||strtolower($tablename)=='ld_servicecontracts'||strtolower($tablename)=='ld_servicecontractscf')
        {
            return true;
        }
        
        return false;
    }

}
?>